Index: /palm/trunk/SOURCE/init_grid.f90
===================================================================
--- /palm/trunk/SOURCE/init_grid.f90	(revision 4456)
+++ /palm/trunk/SOURCE/init_grid.f90	(revision 4457)
@@ -25,4 +25,8 @@
 ! -----------------
 ! $Id$
+! use statement for exchange horiz added,
+! bugfix for call of exchange horiz 2d
+! 
+! 4444 2020-03-05 15:59:50Z raasch
 ! bugfix: cpp-directives for serial mode added
 ! 
@@ -934,4 +938,7 @@
         ONLY:  bc_lr_cyc, bc_ns_cyc, message_string, ocean_mode
 
+    USE exchange_horiz_mod,                                                    &
+        ONLY:  exchange_horiz_int, exchange_horiz_2d
+
     USE indices,                                                               &
         ONLY:  nbgp, nx, nxl, nxlg, nxr, nxrg, ny, nyn, nyng, nys, nysg, nzb,  &
@@ -1315,5 +1322,5 @@
 !--    initialization of building-surface properties.
        IF ( ALLOCATED( buildings_f%oro_max ) )  THEN
-          CALL exchange_horiz_2d( buildings_f%oro_max(:,:), nbgp )
+          CALL exchange_horiz_2d( buildings_f%oro_max(:,:) )
        ENDIF
 !
@@ -1377,4 +1384,7 @@
     USE control_parameters,                                                    &
         ONLY:  bc_lr_cyc, bc_ns_cyc, message_string
+
+    USE exchange_horiz_mod,                                                    &
+        ONLY:  exchange_horiz_int, exchange_horiz_2d_byte, exchange_horiz_2d_int
 
     USE indices,                                                               &
@@ -1592,4 +1602,7 @@
                tunnel_wall_depth
          
+    USE exchange_horiz_mod,                                                    &
+        ONLY:  exchange_horiz_int
+
     USE grid_variables,                                                        &
         ONLY:  dx, dy
@@ -2182,4 +2195,7 @@
                scalar_advec, topography, use_surface_fluxes, use_top_fluxes
 
+    USE exchange_horiz_mod,                                                    &
+        ONLY:  exchange_horiz_int
+
     USE indices,                                                               &
         ONLY:  nbgp, nx, nxl, nxlg, nxr, nxrg, ny, nyn, nyng, nys, nysg, nzb,  &
Index: /palm/trunk/SOURCE/init_pt_anomaly.f90
===================================================================
--- /palm/trunk/SOURCE/init_pt_anomaly.f90	(revision 4456)
+++ /palm/trunk/SOURCE/init_pt_anomaly.f90	(revision 4457)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! use statement for exchange horiz added
+! 
+! 4360 2020-01-07 11:25:50Z suehring
 ! Introduction of wall_flags_total_0, which currently sets bits based on static
 ! topography information used in wall_flags_static_0
@@ -52,4 +55,7 @@
 
     USE control_parameters
+
+    USE exchange_horiz_mod,                                                    &
+        ONLY:  exchange_horiz
 
     USE grid_variables,                                                        &
Index: /palm/trunk/SOURCE/init_rankine.f90
===================================================================
--- /palm/trunk/SOURCE/init_rankine.f90	(revision 4456)
+++ /palm/trunk/SOURCE/init_rankine.f90	(revision 4457)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! use statement for exchange horiz added
+! 
+! 4360 2020-01-07 11:25:50Z suehring
 ! Corrected "Former revisions" section
 ! 
@@ -50,4 +53,7 @@
     USE basic_constants_and_equations_mod,                                     &
         ONLY:  pi
+
+    USE exchange_horiz_mod,                                                    &
+        ONLY:  exchange_horiz
 
     USE grid_variables,                                                        &
Index: /palm/trunk/SOURCE/lagrangian_particle_model_mod.f90
===================================================================
--- /palm/trunk/SOURCE/lagrangian_particle_model_mod.f90	(revision 4456)
+++ /palm/trunk/SOURCE/lagrangian_particle_model_mod.f90	(revision 4457)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! use statement for exchange horiz added
+! 
+! 4444 2020-03-05 15:59:50Z raasch
 ! bugfix: cpp-directives for serial mode added
 ! 
@@ -1772,4 +1775,7 @@
  SUBROUTINE lpm_init_sgs_tke
 
+    USE exchange_horiz_mod,                                                    &
+        ONLY:  exchange_horiz
+
     USE statistics,                                                            &
         ONLY:  flow_statistics_called, hom, sums, sums_l
@@ -2014,4 +2020,7 @@
 !------------------------------------------------------------------------------!  
  SUBROUTINE lpm_actions( location )
+
+    USE exchange_horiz_mod,                                                    &
+        ONLY:  exchange_horiz
 
     CHARACTER (LEN=*), INTENT(IN) ::  location !< call location string
Index: /palm/trunk/SOURCE/nesting_offl_mod.f90
===================================================================
--- /palm/trunk/SOURCE/nesting_offl_mod.f90	(revision 4456)
+++ /palm/trunk/SOURCE/nesting_offl_mod.f90	(revision 4457)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! use statement for exchange horiz added
+! 
+! 4360 2020-01-07 11:25:50Z suehring
 ! Bugfix, time coordinate is relative to origin_time rather than to 00:00:00 
 ! UTC.
@@ -947,4 +950,7 @@
 !------------------------------------------------------------------------------!
     SUBROUTINE nesting_offl_bc                     
+
+       USE exchange_horiz_mod,                                                    &
+           ONLY:  exchange_horiz
 
        INTEGER(iwp) ::  i !< running index x-direction
Index: /palm/trunk/SOURCE/netcdf_data_input_mod.f90
===================================================================
--- /palm/trunk/SOURCE/netcdf_data_input_mod.f90	(revision 4456)
+++ /palm/trunk/SOURCE/netcdf_data_input_mod.f90	(revision 4457)
@@ -25,4 +25,8 @@
 ! -----------------
 ! $Id$
+! use statement for exchange horiz added,
+! bugfixes for calls of exchange horiz 2d
+! 
+! 4435 2020-03-03 10:38:41Z raasch
 ! temporary bugfix to avoid compile problems with older NetCDFD libraries on IMUK machines
 ! 
@@ -1532,4 +1536,7 @@
            ONLY:  land_surface, urban_surface
 
+       USE exchange_horiz_mod,                                                 &
+           ONLY:  exchange_horiz_2d, exchange_horiz_2d_byte, exchange_horiz_2d_int
+
        USE indices,                                                            &
            ONLY:  nbgp, nxl, nxr, nyn, nys
@@ -2053,5 +2060,5 @@
                                      nys, nyn, nxl, nxr )
           DO  k = 0, nz_soil
-             CALL exchange_horiz_2d_int(                                       &  
+             CALL exchange_horiz_2d_byte(                                       &
                         soil_type_f%var_3d(k,:,:), nys, nyn, nxl, nxr, nbgp )
           ENDDO
@@ -2063,5 +2070,5 @@
                                      nys, nyn, nxl, nxr )
           DO  k = 0, surface_fraction_f%nf-1
-             CALL exchange_horiz_2d( surface_fraction_f%frac(k,:,:), nbgp )
+             CALL exchange_horiz_2d( surface_fraction_f%frac(k,:,:) )
           ENDDO
        ENDIF
@@ -2072,5 +2079,5 @@
                                      nys, nyn, nxl, nxr )
           DO  k = 0, building_pars_f%np-1
-             CALL exchange_horiz_2d( building_pars_f%pars_xy(k,:,:), nbgp )
+             CALL exchange_horiz_2d( building_pars_f%pars_xy(k,:,:) )
           ENDDO
        ENDIF
@@ -2081,5 +2088,5 @@
                                      nys, nyn, nxl, nxr )
           DO  k = 0, albedo_pars_f%np-1
-             CALL exchange_horiz_2d( albedo_pars_f%pars_xy(k,:,:), nbgp )
+             CALL exchange_horiz_2d( albedo_pars_f%pars_xy(k,:,:) )
           ENDDO
        ENDIF
@@ -2090,5 +2097,5 @@
                                      nys, nyn, nxl, nxr )
           DO  k = 0, pavement_pars_f%np-1
-             CALL exchange_horiz_2d( pavement_pars_f%pars_xy(k,:,:), nbgp )
+             CALL exchange_horiz_2d( pavement_pars_f%pars_xy(k,:,:) )
           ENDDO
        ENDIF
@@ -2099,5 +2106,5 @@
                                      nys, nyn, nxl, nxr )
           DO  k = 0, vegetation_pars_f%np-1
-             CALL exchange_horiz_2d( vegetation_pars_f%pars_xy(k,:,:), nbgp )
+             CALL exchange_horiz_2d( vegetation_pars_f%pars_xy(k,:,:) )
           ENDDO
        ENDIF
@@ -2108,5 +2115,5 @@
                                      nys, nyn, nxl, nxr )
           DO  k = 0, water_pars_f%np-1
-             CALL exchange_horiz_2d( water_pars_f%pars_xy(k,:,:), nbgp )
+             CALL exchange_horiz_2d( water_pars_f%pars_xy(k,:,:) )
           ENDDO
        ENDIF
@@ -2117,5 +2124,5 @@
                                      nys, nyn, nxl, nxr )
           DO  k = 0, root_area_density_lsm_f%nz-1
-             CALL exchange_horiz_2d( root_area_density_lsm_f%var(k,:,:), nbgp )
+             CALL exchange_horiz_2d( root_area_density_lsm_f%var(k,:,:) )
           ENDDO
        ENDIF
@@ -2128,5 +2135,5 @@
                                         nys, nyn, nxl, nxr )
              DO  k = 0, soil_pars_f%np-1
-                CALL exchange_horiz_2d( soil_pars_f%pars_xy(k,:,:), nbgp )
+                CALL exchange_horiz_2d( soil_pars_f%pars_xy(k,:,:) )
              ENDDO
              
@@ -2139,6 +2146,5 @@
              DO  k2 = 0, soil_pars_f%nz-1
                 DO  k = 0, soil_pars_f%np-1
-                   CALL exchange_horiz_2d( soil_pars_f%pars_xyz(k,k2,:,:),     &
-                                           nbgp )
+                   CALL exchange_horiz_2d( soil_pars_f%pars_xyz(k,k2,:,:) )
                 ENDDO
              ENDDO
@@ -2155,5 +2161,5 @@
              DO  k = 0, pavement_subsurface_pars_f%np-1
                 CALL exchange_horiz_2d(                                        &
-                           pavement_subsurface_pars_f%pars_xyz(k,k2,:,:), nbgp )
+                           pavement_subsurface_pars_f%pars_xyz(k,k2,:,:) )
              ENDDO
           ENDDO
@@ -2287,4 +2293,7 @@
        USE control_parameters,                                                 &
            ONLY:  message_string, topography
+
+       USE exchange_horiz_mod,                                                 &
+           ONLY:  exchange_horiz_2d_byte, exchange_horiz_2d_int
 
        USE grid_variables,                                                     &
Index: /palm/trunk/SOURCE/palm.f90
===================================================================
--- /palm/trunk/SOURCE/palm.f90	(revision 4456)
+++ /palm/trunk/SOURCE/palm.f90	(revision 4457)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! use statement for exchange horiz added
+! 
+! 4444 2020-03-05 15:59:50Z raasch
 ! bugfix: cpp-directives for serial mode added
 ! 
@@ -105,4 +108,7 @@
 
 #if defined( __parallel )
+    USE exchange_horiz_mod,                                                    &
+        ONLY:  exchange_horiz
+
     USE indices,                                                               &
         ONLY:  nbgp
Index: /palm/trunk/SOURCE/plant_canopy_model_mod.f90
===================================================================
--- /palm/trunk/SOURCE/plant_canopy_model_mod.f90	(revision 4456)
+++ /palm/trunk/SOURCE/plant_canopy_model_mod.f90	(revision 4457)
@@ -27,4 +27,7 @@
 ! -----------------
 !
+! use statement for exchange horiz added
+! 
+! 
 ! $Id$
 ! (salim) removed the error message PA0672 to consider PC 3d data via ascii file
@@ -972,4 +975,7 @@
     SUBROUTINE pcm_init
 
+       USE exchange_horiz_mod,                                                    &
+           ONLY:  exchange_horiz
+
        INTEGER(iwp) ::  i   !< running index
        INTEGER(iwp) ::  j   !< running index
@@ -1540,4 +1546,7 @@
     SUBROUTINE pcm_read_plant_canopy_3d
 
+       USE exchange_horiz_mod,                                                    &
+           ONLY:  exchange_horiz
+
        INTEGER(iwp)                        ::  dtype     !< type of input data (1=lad)
        INTEGER(iwp)                        ::  pctype    !< type of plant canopy (deciduous,non-deciduous,...)
Index: /palm/trunk/SOURCE/poismg_mod.f90
===================================================================
--- /palm/trunk/SOURCE/poismg_mod.f90	(revision 4456)
+++ /palm/trunk/SOURCE/poismg_mod.f90	(revision 4457)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! use statement for exchange horiz added
+! 
+! 4432 2020-02-28 07:43:21Z raasch
 ! bugfix for previous revision (vector directive was changed by mistake)
 ! 
@@ -73,4 +76,7 @@
     USE cpulog,                                                                &
         ONLY:  cpu_log, log_point_s
+
+    USE exchange_horiz_mod,                                                    &
+        ONLY:  exchange_horiz
 
     USE kinds
Index: /palm/trunk/SOURCE/poismg_noopt_mod.f90
===================================================================
--- /palm/trunk/SOURCE/poismg_noopt_mod.f90	(revision 4456)
+++ /palm/trunk/SOURCE/poismg_noopt_mod.f90	(revision 4457)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! use statement for exchange horiz added
+! 
+! 4429 2020-02-27 15:24:30Z raasch
 ! bugfix: cpp-directives added for serial mode
 ! 
@@ -70,4 +73,7 @@
     USE cpulog,                                                                &
         ONLY:  cpu_log, log_point_s
+
+    USE exchange_horiz_mod,                                                    &
+        ONLY:  exchange_horiz, exchange_horiz_int
 
     USE kinds
Index: /palm/trunk/SOURCE/pres.f90
===================================================================
--- /palm/trunk/SOURCE/pres.f90	(revision 4456)
+++ /palm/trunk/SOURCE/pres.f90	(revision 4457)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! use statement for exchange horiz added
+! 
+! 4360 2020-01-07 11:25:50Z suehring
 ! Introduction of wall_flags_total_0, which currently sets bits based on static
 ! topography information used in wall_flags_static_0
@@ -69,4 +72,7 @@
     USE cpulog,                                                                &
         ONLY:  cpu_log, log_point, log_point_s
+
+    USE exchange_horiz_mod,                                                    &
+        ONLY:  exchange_horiz
 
     USE grid_variables,                                                        &
Index: /palm/trunk/SOURCE/radiation_model_mod.f90
===================================================================
--- /palm/trunk/SOURCE/radiation_model_mod.f90	(revision 4456)
+++ /palm/trunk/SOURCE/radiation_model_mod.f90	(revision 4457)
@@ -28,4 +28,7 @@
 ! -----------------
 ! $Id$
+! use statement for exchange horiz added
+! 
+! 4452 2020-03-10 20:15:32Z suehring
 ! Bugfix in calc_albedo
 !
@@ -3994,4 +3997,7 @@
 
 #if defined ( __rrtmg )
+       USE exchange_horiz_mod,                                                 &
+           ONLY:  exchange_horiz
+
        USE indices,                                                            &
            ONLY:  nbgp
Index: /palm/trunk/SOURCE/salsa_mod.f90
===================================================================
--- /palm/trunk/SOURCE/salsa_mod.f90	(revision 4456)
+++ /palm/trunk/SOURCE/salsa_mod.f90	(revision 4457)
@@ -26,4 +26,7 @@
 ! -----------------
 ! $Id$
+! use statement for exchange horiz added
+! 
+! 4442 2020-03-04 19:21:13Z suehring
 ! Change order of dimension in surface array %frac to allow for better 
 ! vectorization.
@@ -7871,4 +7874,7 @@
         ONLY:  cpu_log, log_point_s
 
+    USE exchange_horiz_mod,                                                    &
+        ONLY:  exchange_horiz
+
     IMPLICIT NONE
 
@@ -12390,4 +12396,7 @@
         ONLY:  bc_dirichlet_l, bc_dirichlet_n, bc_dirichlet_r, bc_dirichlet_s, dt_3d,              &
                time_since_reference_point
+
+    USE exchange_horiz_mod,                                                    &
+        ONLY:  exchange_horiz
 
     USE indices,                                                                                   &
Index: /palm/trunk/SOURCE/sor.f90
===================================================================
--- /palm/trunk/SOURCE/sor.f90	(revision 4456)
+++ /palm/trunk/SOURCE/sor.f90	(revision 4457)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! use statement for exchange horiz added
+! 
+! 4360 2020-01-07 11:25:50Z suehring
 ! Corrected "Former revisions" section
 ! 
@@ -43,12 +46,4 @@
         ONLY:  rho_air, rho_air_zw
 
-    USE grid_variables,                                                        &
-        ONLY:  ddx2, ddy2
-
-    USE indices,                                                               &
-        ONLY:  nbgp, nxl, nxlg, nxr, nxrg, nyn, nyng, nys, nysg, nz, nzb, nzt
-
-    USE kinds
-
     USE control_parameters,                                                    &
         ONLY:  bc_dirichlet_l, bc_dirichlet_n, bc_dirichlet_r,                 &
@@ -56,4 +51,15 @@
                bc_radiation_n, bc_radiation_r, bc_radiation_s, ibc_p_b,        &
                ibc_p_t, n_sor, omega_sor
+
+    USE exchange_horiz_mod,                                                    &
+        ONLY:  exchange_horiz
+
+    USE grid_variables,                                                        &
+        ONLY:  ddx2, ddy2
+
+    USE indices,                                                               &
+        ONLY:  nbgp, nxl, nxlg, nxr, nxrg, nyn, nyng, nys, nysg, nz, nzb, nzt
+
+    USE kinds
 
     IMPLICIT NONE
Index: /palm/trunk/SOURCE/synthetic_turbulence_generator_mod.f90
===================================================================
--- /palm/trunk/SOURCE/synthetic_turbulence_generator_mod.f90	(revision 4456)
+++ /palm/trunk/SOURCE/synthetic_turbulence_generator_mod.f90	(revision 4457)
@@ -1257,4 +1257,7 @@
 !------------------------------------------------------------------------------!
  SUBROUTINE stg_main
+
+    USE exchange_horiz_mod,                                                    &
+        ONLY:  exchange_horiz
 
     INTEGER(iwp) :: i           !< grid index in x-direction
Index: /palm/trunk/SOURCE/time_integration.f90
===================================================================
--- /palm/trunk/SOURCE/time_integration.f90	(revision 4456)
+++ /palm/trunk/SOURCE/time_integration.f90	(revision 4457)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! use statement for exchange horiz added
+! 
+! 4444 2020-03-05 15:59:50Z raasch
 ! bugfix: cpp-directives for serial mode added
 ! 
@@ -276,4 +279,7 @@
         ONLY:  doq_calculate,                                                                      &
                timestep_number_at_prev_calc
+
+    USE exchange_horiz_mod,                                                                        &
+        ONLY:  exchange_horiz
 
     USE flight_mod,                                                                                &
Index: /palm/trunk/SOURCE/time_integration_spinup.f90
===================================================================
--- /palm/trunk/SOURCE/time_integration_spinup.f90	(revision 4456)
+++ /palm/trunk/SOURCE/time_integration_spinup.f90	(revision 4457)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! use statement for exchange horiz added
+! 
+! 4444 2020-03-05 15:59:50Z raasch
 ! bugfix: cpp-directives for serial mode added
 ! 
@@ -90,4 +93,7 @@
     USE diagnostic_output_quantities_mod,                                      &
         ONLY:  doq_calculate
+
+    USE exchange_horiz_mod,                                                    &
+        ONLY:  exchange_horiz
 
     USE indices,                                                               &
Index: /palm/trunk/SOURCE/turbulence_closure_mod.f90
===================================================================
--- /palm/trunk/SOURCE/turbulence_closure_mod.f90	(revision 4456)
+++ /palm/trunk/SOURCE/turbulence_closure_mod.f90	(revision 4457)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! use statement for exchange horiz added
+! 
+! 4433 2020-02-28 22:14:43Z gronemeier
 ! remove warning for newly implemented RANS mode
 !
@@ -1366,4 +1369,7 @@
     USE control_parameters,                                                    &
         ONLY:  f, message_string, wall_adjustment, wall_adjustment_factor
+
+    USE exchange_horiz_mod,                                                    &
+        ONLY:  exchange_horiz, exchange_horiz_int
 
     USE grid_variables,                                                        &
@@ -4439,4 +4445,7 @@
                e_min
 
+    USE exchange_horiz_mod,                                                    &
+        ONLY:  exchange_horiz
+
     USE surface_layer_fluxes_mod,                                              &
         ONLY:  phi_m
Index: /palm/trunk/SOURCE/urban_surface_mod.f90
===================================================================
--- /palm/trunk/SOURCE/urban_surface_mod.f90	(revision 4456)
+++ /palm/trunk/SOURCE/urban_surface_mod.f90	(revision 4457)
@@ -28,4 +28,7 @@
 ! -----------------
 ! $Id$
+! use statement for exchange horiz added
+! 
+! 4442 2020-03-04 19:21:13Z suehring
 ! Change order of dimension in surface arrays %frac, %emissivity and %albedo 
 ! to allow for better vectorization in the radiation interactions.
@@ -7752,4 +7755,7 @@
 !------------------------------------------------------------------------------!
     SUBROUTINE usm_surface_energy_balance( during_spinup )
+
+        USE exchange_horiz_mod,                                                    &
+            ONLY:  exchange_horiz
 
 
Index: /palm/trunk/SOURCE/vertical_nesting_mod.f90
===================================================================
--- /palm/trunk/SOURCE/vertical_nesting_mod.f90	(revision 4456)
+++ /palm/trunk/SOURCE/vertical_nesting_mod.f90	(revision 4457)
@@ -26,4 +26,7 @@
 ! -----------------
 ! $Id$
+! use statement for exchange horiz added
+! 
+! 4444 2020-03-05 15:59:50Z raasch
 ! bugfix: cpp-directives for serial mode added
 ! 
@@ -76,4 +79,7 @@
 !------------------------------------------------------------------------------!
  MODULE vertical_nesting_mod
+
+    USE exchange_horiz_mod,                                                    &
+        ONLY:  exchange_horiz, exchange_horiz_2d
 
     USE kinds
Index: /palm/trunk/SOURCE/wind_turbine_model_mod.f90
===================================================================
--- /palm/trunk/SOURCE/wind_turbine_model_mod.f90	(revision 4456)
+++ /palm/trunk/SOURCE/wind_turbine_model_mod.f90	(revision 4457)
@@ -26,4 +26,7 @@
 ! -----------------
 ! $Id$
+! use statement for exchange horiz added
+! 
+! 4447 2020-03-06 11:05:30Z oliver.maas
 ! renamed wind_turbine_parameters namelist variables
 ! 
@@ -978,4 +981,7 @@
            ONLY:  dz_stretch_level_start
     
+       USE exchange_horiz_mod,                                                    &
+           ONLY:  exchange_horiz
+
        IMPLICIT NONE
 
